/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */
#ifndef _NMM_OSDELEMENTBASE_HPP
#define _NMM_OSDELEMENTBASE_HPP

#include "nmm/nmm_prefix.hpp"

//#include "nmm/NMMTypes.hpp"

#include "nmm/Result.hpp"

#include <string>
#include "visibility.hpp"
namespace NMM {
  /**
   * OSD Element Base
   */
  class DLLEXPORT OSDElementBase{
  public:
    virtual ~OSDElementBase() {}
    
    virtual Result selectLeft()  = 0;
    virtual Result selectRight() = 0;
    virtual Result selectUp()    = 0;
    virtual Result selectDown()  = 0;

    virtual void setHeader(std::string) {};
    virtual void setDimension(uint, uint) {};
    virtual void setPosition(uint,uint) {};
    virtual void setColors(uint,uint,uint,uint,uint) {};
    virtual void deSelectWindow() {};
    virtual void selectWindow(unsigned int) {};

    virtual void update()        = 0;
    virtual void show()          = 0;
    virtual void hide()          = 0;
    virtual bool isHidden()      = 0;

    virtual unsigned int getSelectedLine()  {return 0;}
    virtual void selectLine(const unsigned int& ) {}
  };
}
#include "nmm/nmm_suffix.hpp"

#endif
